(***********************************************************************)
(*                                                                     *)
(*                           Objective Caml                            *)
(*                                                                     *)
(*            Pierre Weis, projet Cristal, INRIA Rocquencourt          *)
(*                                                                     *)
(*  Copyright 1996 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

(* $Id: lib_version.mli,v 1.1 2015/08/27 10:36:17 fclement Exp $ *)

(** {3 A library to deal with version strings ``a la Caml''} *)

type major = int
and minor = int
and patch = int
;;

type version = major * minor * patch
and t = version
;;

val to_string : version -> string;;

val of_string : string -> version;;
