/***********************************************************************/
/*                                                                     */
/*                              Pio (C++)                              */
/*                                                                     */
/*                    Polyglot Input/Output Library                    */
/*                                                                     */
/*                       EPI Serena, INRIA Paris                       */
/*                                                                     */
/*  Copyright (c) 2005-2017 INRIA.                                     */
/*  Institut National de Recherche en Informatique et en Automatique.  */
/*  All rights reserved. This file is distributed only by permission.  */
/*                                                                     */
/*  Estelle Marchand <Estelle.Marchand@inria.fr>                       */
/*                                                                     */
/***********************************************************************/

/* $Id: parse_io.cpp,v 1.15 2017/05/31 15:54:21 fclement Exp $ */

#include "parse_io.hpp"

namespace io{

  void parse_command_line(int argc, char** argv){

  GetPot command_line(argc,argv);
  if(command_line.search(3,"-h","-help","--help")){
  }

  io::set_prec( command_line.follow( (int) get_prec(),1,"--prec-io") );


  bool BINARY = command_line.search(2,"-bio","--binary-io");
  bool ASCII = command_line.search(2,"-aio","--ascii-io");
  if(BINARY && ASCII){
    std::cerr<<"Error: binary_io and ascii_io options are incompatible."
             <<std::endl;
    exit(1);
  }
  if(BINARY){
    io::set_binary();
  }
  if(ASCII){
    io::set_ascii();
  }

  if(command_line.search(2,"-dio","--debug-io")) set_debug();

  }

}// namespace io
