/***********************************************************************/
/*                                                                     */
/*                              Pio (C++)                              */
/*                                                                     */
/*                    Polyglot Input/Output Library                    */
/*                                                                     */
/*                       EPI Serena, INRIA Paris                       */
/*                                                                     */
/*  Copyright (c) 2005-2017 INRIA.                                     */
/*  Institut National de Recherche en Informatique et en Automatique.  */
/*  All rights reserved. This file is distributed only by permission.  */
/*                                                                     */
/*  Estelle Marchand <Estelle.Marchand@inria.fr>                       */
/*                                                                     */
/***********************************************************************/

/* $Id: single_types.cpp,v 1.13 2017/05/31 15:54:21 fclement Exp $ */

#include "single_types.hpp"

namespace io{

  string type(const int& i,Aim aim){return "%i";}
  string type(const double& d,Aim aim){
    switch(aim){
    case SEND:
      if(get_binary()) return "%bf";
      else return "%f";
      break;
    case RECEIVE:
      if(get_reception_binary()) return "%bf";
      else return "%f";
      break;
    default:
      return "%F";
    }
  }
  string type(const string& S,Aim aim){return "%S";}
  string type(const boolean& b,Aim aim){return "%B";}
  
  
  //   template<class dataType1,class dataType2> string type(pair<dataType1,dataType2>& t){
  //     dataType1 tt;
  //     string s=type(tt);
  //     string res= "(";
  //     res = res+s+", ";
  //     dataType2 ttt;
  //     s=type(ttt);
  //     res=res+s+')';
  //     return res;
  //   }
}
  
