/***********************************************************************/
/*                                                                     */
/*                              Pio (C++)                              */
/*                                                                     */
/*                    Polyglot Input/Output Library                    */
/*                                                                     */
/*                       EPI Serena, INRIA Paris                       */
/*                                                                     */
/*  Copyright (c) 2005-2017 INRIA.                                     */
/*  Institut National de Recherche en Informatique et en Automatique.  */
/*  All rights reserved. This file is distributed only by permission.  */
/*                                                                     */
/*  Estelle Marchand <Estelle.Marchand@inria.fr>                       */
/*                                                                     */
/***********************************************************************/

/* $Id: task.cpp,v 1.13 2017/05/31 15:54:21 fclement Exp $ */

#include "task.hpp"


using namespace std;

namespace io{

  
  string Task::name(){return task_name;}

  Task::Task():task_args(0){_n_args = 0;task_name = "void";is_set = true;}

  Task::Task(string _name,vector<Typed_value> &_args):task_args(_args){task_name = _name;_n_args = _args.size();is_set = true;}

  Task::Task(string _name,const Typed_value& arg):task_args(1,arg){task_name = _name;_n_args = 1;is_set = true;}

  Task::Task(string _name,int n):task_args(n){task_name = _name;_n_args = n;is_set = false;}

  Task::~Task(){}  

  int Task::n_args(){return _n_args;}
  
  vector<Typed_value> &  Task::args(){return task_args;}

  void Task::set_args(vector<Typed_value>& new_args){
    if(new_args.size()==_n_args){ 
      task_args = new_args; 
      is_set = true;}
    else {
      cerr<<"wrong arg size : "<<new_args.size()<<" instead of "<<_n_args<<endl;
      exit(-1);
    }
  }
      
  void Task::set_arg(const Typed_value& new_arg){
    if(_n_args == 1){ 
      task_args[0] = new_arg; 
      is_set = true;}
    else {
      cerr<<"wrong arg size : "<<1<<" instead of "<<_n_args<<endl;
      exit(-1);
    }
  }
  

}
