(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2013-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: model.mli,v 1.8 2017/11/07 20:57:42 fclement Exp $ *)

open Wire_types;;
open Worker_types;;

val init_engine :
  (Upervasives.function_name -> dimension -> dimension -> unit) ->
  init_engine
;;

val grad_engine : grad_engine;;

val optim_engine :
  (partition -> coarse_parameter -> fine_parameter) -> optim_engine
;;

val final_engine : final_engine;;

(**/**)

val get_dim : unit -> Unatural.t;;
val get_data : unit -> float Umatrix.t;;
val get_selection_array : unit -> Upervasives.select array;;
val masking : Upervasives.select array -> 'a Umatrix.t -> 'a Umatrix.t;;
