(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2013-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: uaffine_plane_spec.mli,v 1.6 2017/11/07 20:57:39 fclement Exp $ *)

(** {3 Affine plane specification} *)

module type STRUCTURE =
sig
  type t;;

  val _0_ : t;;
  val _1_ : t;;

  val add : t -> t -> t;;
  val sub : t -> t -> t;;
end
;;

module type AFFINE_PLANE =
sig
  type component;;

  type point = component * component;;
  type vector = component * component;;

  val origin : point;;
  val null : vector;;

  val add : point -> vector -> point;;
  val sub : point -> point -> vector;;
end
;;

module type MAKER =
  functor (S : STRUCTURE) ->
  AFFINE_PLANE with type component = S.t
;;
