(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2013-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: uhistory_types.mli,v 1.10 2017/05/31 17:27:35 fclement Exp $ *)

(** {3 History types} *)

(** {6 Start mode} *)

type start_mode =
  | Cold_start
  | Warm_start
;;

type history_file_name = Ufilename.t;;

type write_directory_name = Ufilename.t;;

(** {6 History mode} *)

type history_step_mode =
  | Last
  | Full
;;

type base_name = Ufilename.t;;

type checkpointing = base_name option;;

type history_mode = history_step_mode * checkpointing

(** {6 History} *)

type state_number = Unatural.t

type 'a h_state =
  {
   state_number : state_number;
   state : 'a;
  }
;;

type 'a h_list = 'a h_state Ulist1.list1;;

type ('a, 'b, 'c) t =
  {
   configuration : 'a;
   constants : 'b;
   h_mode : history_mode;
   h_list : 'c h_list;
  }
;;
