(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2013-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: uhomogeneous_tuple.mli,v 1.10 2017/11/07 20:57:39 fclement Exp $ *)

(** {3 Homogeneous tuple} *)

module Make : Uhomogeneous_tuple_spec.MAKER;;

module Single :
  Uhomogeneous_tuple_spec.HOMOGENEOUS_TUPLE with type 'a t = 'a
;;

module Double :
  Uhomogeneous_tuple_spec.HOMOGENEOUS_TUPLE with type 'a t = 'a * 'a
;;

module Triple :
  Uhomogeneous_tuple_spec.HOMOGENEOUS_TUPLE with type 'a t = 'a * 'a * 'a
;;

module Vector :
  functor (V : Uvector_spec.VECTOR) ->
  Uhomogeneous_tuple_spec.HOMOGENEOUS_TUPLE with type 'a t = 'a V.t
;;
