(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2013-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: ustring_command_option_spec.mli,v 1.16 2017/11/07 20:57:39 fclement Exp $ *)

(** {3 String command option specification} *)

module type STRUCTURE =
sig
  type t;;

  val name : string;;
  val plural_name : string;;
  val default : t;;
  val all : t list;;
  val of_string : string -> t;;
  val to_string : t -> string;;
  val opt_short_option_key : string option;;
end
;;

module type MAKER =
  functor (S : STRUCTURE) ->
sig
  type t = S.t;;

  val get : unit -> t;;
  val rco_with_sok :
    Uoption_key.short_option_key_status *
    Ucommand_option.regular_command_option
  ;;
end
;;
