(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2013-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: uvector_types_spec.mli,v 1.10 2017/11/07 20:57:39 fclement Exp $ *)

(** {3 Fixed dimension vector private type specification} *)

module type DIMENSION = sig val get_dim : unit -> Unatural.t;; end;;

module type MAKER =
  functor (Dim : DIMENSION) ->
sig
  type 'a t = private 'a array;;

  val to_vector : 'a array -> 'a t;;
  external of_vector : 'a t -> 'a array = "%identity";;
end
;;
