(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2013-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: umatrix_mask.mli,v 1.5 2017/10/27 13:30:02 fclement Exp $ *)

(** {3 Matrix masks} *)

type length = Upervasives.length;;

type selection_matrix = Upervasives.select Umatrix.t;;

type size = length * length;;

type nat_couple = Unatural.t * Unatural.t;;

type mask =
  {
   size : size;
   body : mask_body;
  }
and t = mask
and mask_body =
  | Empty
  | Cell of cell
  | Range of range
  | Rectangle of corners
  | Union of mask_body list
and corners =
  {
   upper_left : cell;
   lower_right : cell;
  }
and range =
  {
   left : cell;
   right : cell;
  }
and cell = nat_couple
;;

val selection_matrix : t -> selection_matrix;;

val selection_length : selection_matrix -> length
(** The number of elements to keep. *)
;;
