(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2013-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: umatrix_universe.ml,v 1.10 2017/11/07 20:57:40 fclement Exp $*)

(* Numbering matrix slots. *)

module P = Upervasives;;
module A = Uarray;;

module Mnum = Umatrix_numbering;;

type size = Mnum.size;;
type element = Mnum.key;;
type index = Mnum.value;;

type t =
  {
   tables : Mnum.t;
   cardinal : P.length;
  }
;;

(* Construction function. *)

let gen_make mh = { tables = mh; cardinal = Mnum.length mh; };;

let make sz = gen_make (Mnum.make sz)
and of_mask mask = gen_make (Mnum.of_mask mask)
and make_masked mask_chi = gen_make (Mnum.make_masked mask_chi)
;;

(* Access functions. *)

let cardinal mu = mu.cardinal;;

let size mu = Mnum.size mu.tables;;

let index mu = Mnum.value_of_key mu.tables;;

let element mu = Mnum.key_of_value mu.tables;;

let sub_elements mu = A.map (element mu);;
