(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2013-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: history.ml,v 1.13 2017/11/07 20:57:41 fclement Exp $ *)

(* Shortcuts for the Basement library. *)

module H = Uhistory;;

(* Shortcuts for the Refinement library. *)

module Config = Configuration;;

(* History operations. *)

module Make =
  functor (Scal : Scalar_spec.SCALAR) ->
  functor (Comps : Components_spec.COMPONENTS) ->
struct
  module St = State.Make (Scal) (Comps);;
  module Bb = St.Bb;;

  include H.Make (Config) (St);;

  (* Early parse of the command line to get the parameter size before
     setting up graphical capabilities when applying Display.Make functor. *)
  (* Step 0. *)
  let h_init = initialization ();;
end
;;
