(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2013-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: scalar_spec.mli,v 1.22 2017/11/07 20:57:41 fclement Exp $ *)

(** {3 Scalar specification} *)

open Refinement_types;;

module type SCALAR =
sig
  include Uordered_field_spec.ORDERED_FIELD;;

  val initial_zonation : t partition -> t zonation;;

  val vfoi_init : t forced_zonation -> t forced_zonation;;
  val vfoi_add_zones_overall_best :
    t forced_zonation -> t forced_zonation -> t forced_zonation
  ;;
  val vfoi_add_zones_best_in_a_family :
    t forced_zonation -> t forced_zonation -> t forced_zonation
  ;;
end
;;

module type MAKER =
  functor (Of : Uordered_field_spec.ORDERED_FIELD) -> SCALAR
;;
