(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2013-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: wire_types.mli,v 1.7 2017/10/25 15:25:38 fclement Exp $ *)

type length = Upervasives.length;;
type index = Upervasives.index;;

type size = length * length;;
type dimension = length;;

type param = float;;
type cost = float;;

type fine_parameter = param Umatrix.t;;
type fine_gradient = fine_parameter;;

type masked_partition = int Umatrix.t;; (* = partition + mask *)
type partition = Unatural.t Umatrix.t;;
type coarse_parameter = param array array;;
